package com.css.simulation.resource.video.controller;

import api.common.pojo.common.ResponseBodyVO;
import api.common.pojo.po.scene.VehicleTypePO;
import api.common.pojo.vo.scene.SceneAccidentVO;
import api.common.util.LinuxUtil;
import com.css.simulation.resource.video.service.VideoService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
@Slf4j
@RestController
public class VideoController {

    @Resource
    VideoService videoService;
    @Value("${scheduler.video-test-command}")
    String testCommand;


    /**
     * 接受 xosc 文件
     */
    @GetMapping(value = "/generate")
    ResponseBodyVO<String> generateVideo(
            @RequestParam("projectId") String projectId,
            @RequestParam("projectType") String projectType,
            @RequestParam("maxSimulationTime") String maxSimulationTime,
            @RequestParam("taskId") String taskId
    ) {
        return videoService.generateVideo(projectId, projectType, maxSimulationTime,taskId);
    }


    /**
     * 接受 xosc 文件
     */
    @RequestMapping(value = "/test")
    public void testGenerateVideo() throws IOException {
//        LinuxUtil.execute("/root/disk1/simulation-cloud/esmini/code-examples-bin/image-capture /root/disk1/simulation-cloud/esmini/resources/xosc/lane_change_crest.xosc /root/disk1/simulation-cloud/esmini/test/screenshot ");
        LinuxUtil.execute(testCommand);
    }


    @RequestMapping(value = "/uploadToLocal")
    @ResponseBody
    public ResponseBodyVO<Map<String,String>> uploadToLocal(@RequestBody MultipartFile file){
        // 获取文件原本的名字
        String originName = file.getOriginalFilename();
       String fileName=originName.substring(0,originName.lastIndexOf("."));
/*        // 判断文件是否是pdf文件
        Set<String> set = new HashSet<>();
        set.add(".pdf");
        set.add(".doc");
        set.add(".docx");*/
        // 取出文件的后缀
        /*int count = 0;
        for(int i = 0; i < originName.length(); i++){
            if(originName.charAt(i) == '.'){
                count = i;
                break;
            }
        }
        String endName = originName.substring(count); //取出文件类型
       // String fileType = originName.substring(count + 1); //文件类型
        if(!".osgb".contains(endName)){
            //return new String("上传的文件类型错误,只能上传osgb类型的文件");
            return new ResponseBodyVO(ResponseBodyVO.Response.CLIENT_FAILURE, "上传的文件类型错误,只能上传osgb类型的文件");
        }*/
        // 创建保存路径
       //日期格式
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmssSS");
        String format = sdf.format(new Date());
       // String savePath = System.getProperty("user.dir") + "\\" + "files" +   "\\" + fileType + "\\" + format;
       // 保存文件的文件夹
       //String savePath="C:/Users/CSS/Desktop/ive转osgb/20220919";
        String savePath="/root/disk1/simulation-cloud/esmini/resources/models/"+fileName+"/"+ format;
        log.info("车辆模型对应osgb地址:" + savePath);
        File folder = new File(savePath);
        // 判断路径是否存在,不存在则自动创建
        if(!folder.exists()){
            folder.mkdirs();
        }
        String saveName = originName;
        try {
            file.transferTo(new File(folder,saveName));
            Map<String,String> map =new HashMap<>();
            String filePath = savePath + "/" + saveName;
           // return new String("文件路径为:" + filePath);
            map.put("filePath",filePath);
            return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS, map);
        } catch (IOException e){
            return new ResponseBodyVO(ResponseBodyVO.Response.SERVER_FAILURE, e.getMessage());
          //  return new String(e.getMessage());
        }
    }

    @RequestMapping(value = "/test1")
    @ResponseBody
    public ResponseBodyVO<VehicleTypePO> test1(@RequestBody Map<String,String> map) {
        VehicleTypePO po= videoService.vehicleById(map.get("projectId"),map.get("projectType"));
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS, po);
    }


}
